<?php

namespace \Liberty\Service\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for cotizadorCabeceraResponse StructType
 * @subpackage Structs
 */
class CotizadorCabeceraResponse extends AbstractStructBase
{
    /**
     * The codRetorno
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $codRetorno;
    /**
     * The detalleResponse
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \\Liberty\Service\StructType\CotizadorDetalleResponse[]
     */
    public $detalleResponse;
    /**
     * The mensajeRetorno
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $mensajeRetorno;
    /**
     * Constructor method for cotizadorCabeceraResponse
     * @uses CotizadorCabeceraResponse::setCodRetorno()
     * @uses CotizadorCabeceraResponse::setDetalleResponse()
     * @uses CotizadorCabeceraResponse::setMensajeRetorno()
     * @param int $codRetorno
     * @param \\Liberty\Service\StructType\CotizadorDetalleResponse[] $detalleResponse
     * @param string $mensajeRetorno
     */
    public function __construct($codRetorno = null, array $detalleResponse = array(), $mensajeRetorno = null)
    {
        $this
            ->setCodRetorno($codRetorno)
            ->setDetalleResponse($detalleResponse)
            ->setMensajeRetorno($mensajeRetorno);
    }
    /**
     * Get codRetorno value
     * @return int|null
     */
    public function getCodRetorno()
    {
        return $this->codRetorno;
    }
    /**
     * Set codRetorno value
     * @param int $codRetorno
     * @return \\Liberty\Service\StructType\CotizadorCabeceraResponse
     */
    public function setCodRetorno($codRetorno = null)
    {
        // validation for constraint: int
        if (!is_null($codRetorno) && !is_numeric($codRetorno)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($codRetorno)), __LINE__);
        }
        $this->codRetorno = $codRetorno;
        return $this;
    }
    /**
     * Get detalleResponse value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \\Liberty\Service\StructType\CotizadorDetalleResponse[]|null
     */
    public function getDetalleResponse()
    {
        return isset($this->detalleResponse) ? $this->detalleResponse : null;
    }
    /**
     * Set detalleResponse value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \\Liberty\Service\StructType\CotizadorDetalleResponse[] $detalleResponse
     * @return \\Liberty\Service\StructType\CotizadorCabeceraResponse
     */
    public function setDetalleResponse(array $detalleResponse = array())
    {
        foreach ($detalleResponse as $cotizadorCabeceraResponseDetalleResponseItem) {
            // validation for constraint: itemType
            if (!$cotizadorCabeceraResponseDetalleResponseItem instanceof \\Liberty\Service\StructType\CotizadorDetalleResponse) {
                throw new \InvalidArgumentException(sprintf('The detalleResponse property can only contain items of \\Liberty\Service\StructType\CotizadorDetalleResponse, "%s" given', is_object($cotizadorCabeceraResponseDetalleResponseItem) ? get_class($cotizadorCabeceraResponseDetalleResponseItem) : gettype($cotizadorCabeceraResponseDetalleResponseItem)), __LINE__);
            }
        }
        if (is_null($detalleResponse) || (is_array($detalleResponse) && empty($detalleResponse))) {
            unset($this->detalleResponse);
        } else {
            $this->detalleResponse = $detalleResponse;
        }
        return $this;
    }
    /**
     * Add item to detalleResponse value
     * @throws \InvalidArgumentException
     * @param \\Liberty\Service\StructType\CotizadorDetalleResponse $item
     * @return \\Liberty\Service\StructType\CotizadorCabeceraResponse
     */
    public function addToDetalleResponse(\\Liberty\Service\StructType\CotizadorDetalleResponse $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \\Liberty\Service\StructType\CotizadorDetalleResponse) {
            throw new \InvalidArgumentException(sprintf('The detalleResponse property can only contain items of \\Liberty\Service\StructType\CotizadorDetalleResponse, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->detalleResponse[] = $item;
        return $this;
    }
    /**
     * Get mensajeRetorno value
     * @return string|null
     */
    public function getMensajeRetorno()
    {
        return $this->mensajeRetorno;
    }
    /**
     * Set mensajeRetorno value
     * @param string $mensajeRetorno
     * @return \\Liberty\Service\StructType\CotizadorCabeceraResponse
     */
    public function setMensajeRetorno($mensajeRetorno = null)
    {
        // validation for constraint: string
        if (!is_null($mensajeRetorno) && !is_string($mensajeRetorno)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mensajeRetorno)), __LINE__);
        }
        $this->mensajeRetorno = $mensajeRetorno;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \\Liberty\Service\StructType\CotizadorCabeceraResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
