<?php

namespace \Liberty\Service\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for mapCoberturas StructType
 * @subpackage Structs
 */
class MapCoberturas extends AbstractStructBase
{
    /**
     * The entry
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \\Liberty\Service\StructType\Entry[]
     */
    public $entry;
    /**
     * Constructor method for mapCoberturas
     * @uses MapCoberturas::setEntry()
     * @param \\Liberty\Service\StructType\Entry[] $entry
     */
    public function __construct(array $entry = array())
    {
        $this
            ->setEntry($entry);
    }
    /**
     * Get entry value
     * @return \\Liberty\Service\StructType\Entry[]|null
     */
    public function getEntry()
    {
        return $this->entry;
    }
    /**
     * Set entry value
     * @throws \InvalidArgumentException
     * @param \\Liberty\Service\StructType\Entry[] $entry
     * @return \\Liberty\Service\StructType\MapCoberturas
     */
    public function setEntry(array $entry = array())
    {
        foreach ($entry as $mapCoberturasEntryItem) {
            // validation for constraint: itemType
            if (!$mapCoberturasEntryItem instanceof \\Liberty\Service\StructType\Entry) {
                throw new \InvalidArgumentException(sprintf('The entry property can only contain items of \\Liberty\Service\StructType\Entry, "%s" given', is_object($mapCoberturasEntryItem) ? get_class($mapCoberturasEntryItem) : gettype($mapCoberturasEntryItem)), __LINE__);
            }
        }
        $this->entry = $entry;
        return $this;
    }
    /**
     * Add item to entry value
     * @throws \InvalidArgumentException
     * @param \\Liberty\Service\StructType\Entry $item
     * @return \\Liberty\Service\StructType\MapCoberturas
     */
    public function addToEntry(\\Liberty\Service\StructType\Entry $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \\Liberty\Service\StructType\Entry) {
            throw new \InvalidArgumentException(sprintf('The entry property can only contain items of \\Liberty\Service\StructType\Entry, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->entry[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \\Liberty\Service\StructType\MapCoberturas
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
